:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3178,_3172/_3174,_3182):-(retract(dynamicVersion(_3178,_3172/_3174,_3196))->true;true),asserta(dynamicVersion(_3178,_3172/_3174,_3182)).
prim_assertFact('Dynamic.Dynamic'(_3290),'Prelude.()'):-retract(dynamicTime(_3300)),_3314 is _3300+1,assertz(dynamicTime(_3314)),_3290=..[_3328,_3334,_3340,_3346|_3348],_3376=..[_3328,_3314,0|_3348],assertz(user:_3376),logDynamicEvent(_3334,assertz,_3376).
prim_retractFact('Dynamic.Dynamic'(_3478),_3484):-_3478=..[_3488,_3494,_3500,_3506|_3508],_3536=..[_3488,_3524,_3530|_3508],reloadNewestDynamicVersionOf(_3488),retract(dynamicTime(_3546)),_3560 is _3546+1,assertz(dynamicTime(_3560)),call(user:_3536),isInTimeInterval(_3546,_3524,_3530),!,_3610=..[_3488,_3524,_3546|_3508],retract(user:_3536),!,logDynamicEvent(_3494,retract,_3536),assertz(user:_3610),_3484='Prelude.True'.
prim_retractFact(_3776,'Prelude.False').
prim_getDynamicKnowledge(_3812):-reloadNewestDynamicVersions,dynamicTime(_3816),term2partcall('Dynamic.isKnownAtTime'(_3816),1,_3812),(compileWithSharing(function)->makeShare(_3812,_3838);_3838=_3812).
prim_isKnownAtTime(_3916,'Dynamic.Dynamic'(_3912),'Prelude.True'):-_3912=..[_3924,_3930,_3936,_3942|_3944],_3972=..[_3924,_3960,_3966|_3944],call(user:_3972),isInTimeInterval(_3916,_3960,_3966).
isInTimeInterval(_4064,_4066,_4068):-_4064>=_4066,(_4068=0->true;_4064=<_4068).
logDynamicEvent('Dynamic.Temporary',_4160,_4162):-!.
logDynamicEvent('Dynamic.Persistent',_4218,_4220):-_4220=..[_4224,_4230,_4236|_4238],_4266=..[_4224,0,0|_4238],_4284=..[_4218,_4266],user:dynamicPredInfo(_4224/_4292,_4298),logDynamic(_4284,_4298).
logDynamic(_4388,_4390):-dir2tmplockfile(_4390,_4396),lockWithFileIfNotInTransaction(_4396),executeWithFinalize((dir2logfile(_4390,_4406),open(_4406,append,_4414),writeq(_4414,_4388),put_code(_4414,46),nl(_4414),flush_output(_4414),close(_4414),addChangePid(_4390)),unlockWithFileIfNotInTransaction(_4396)).
executeWithFinalize(_4552,_4554):-on_exception(_4562,_4552,(call(_4554),printError(_4562),!,fail)),!,call(_4554).
executeWithFinalize(_4650,_4652):-call(_4652),!,fail.
prim_startTransaction(_4714):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4776,initTransaction(_4714),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4776),fail)),!.
initTransaction(_4858):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4862)),_4858 is _4862+1,assertz(dynamicTime(_4858)),logAllDynamicPreds(startTransaction(_4858)).
prim_commitTransaction(_4962,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_4962)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5046):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5054),map1partialM(prim_dynamic:addChangePid(0),_5054),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5160):-findall(_5164,isDynamicDir(_5164),_5172),sort(_5172,_5160).
isDynamicDir(_5222):-user:dynamicPredInfo(_5226,_5222),\+_5222=''.
logAllDynamicPreds(_5288):-getDynamicDirs(_5292),map1partialM(prim_dynamic:logDynamic(_5288),_5292).
initializeDynamic:-user:dynamicPredInfo(_5352/_5354,_5360),initializeDynamic(_5360,_5352/_5354),fail.
initializeDynamic.
initializeDynamic('',_5430/_5432):-!,retractAllFacts(_5430/_5432).
initializeDynamic(_5506,_5500/_5502):-existsDirectory(_5506),!,checkDynSpec(_5506,_5500/_5502),setDynamicVersion(_5506,_5500/_5502,0),!.
initializeDynamic(_5608,_5610):-existsFile(_5608),!,appendAtom('ERROR: Directory "',_5608,_5622),appendAtom(_5622,'" for dynamic entries cannot be created!',_5630),writeErr(_5630),nlErr,!,fail.
initializeDynamic(_5728,_5722/_5724):-upDirectory(_5728,_5736),(existsDirectory(_5736)->createDynamicDir(_5728,_5722/_5724),setDynamicVersion(_5728,_5722/_5724,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5728),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5914,_5916):-atom_codes(_5914,_5922),append(_5932,[47|_5928],_5922),\+member(47,_5928),!,atom_codes(_5916,_5932).
upDirectory(_6022,'.').
checkDynSpec(_6064,_6058/_6060):-dir2specfile(_6064,_6072),existsFile(_6072),readPrologTermFile(_6072,_6082),dynamicSpec(_6058/_6060,_6082),!.
checkDynSpec(_6164,_6166):-appendAtom('ERROR: Directory "',_6164,_6174),appendAtom(_6174,'" contains no matching dynamic entries!',_6182),writeErr(_6182),nlErr,!,fail.
replayLogFile(_6268,_6262/_6264):-dir2tmplockfile(_6268,_6276),lockWithFileIfNotInTransaction(_6276),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6268,_6262/_6264),unlockWithFileIfNotInTransaction(_6276)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6384,_6378/_6380):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6384),writeErr('\'...'),nlErr;true),getRunTime(_6438),ensurePakcsVersion(_6384),dir2dbfile(_6384,_6448),dir2pofile(_6384,_6454),consultPrologorPOFile(_6448,_6454),dir2logfile(_6384,_6466),open(_6466,read,_6474),(atEndOfStream(_6474)->close(_6474);assert(replayStatus(unchanged)),repeat,on_exception(_6504,readAndReplay(_6474),((printError(_6504)->true;true),writeErr('ERROR during reading of '),writeErr(_6466),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6474),retract(replayStatus(_6568)),writeNewDatabaseIfChanged(_6378/_6380,_6384,_6568)),updateDynFactsIfNecessary(_6384,_6378/_6380),readDynamicVersion(_6384,_6640),setDynamicVersion(_6384,_6378/_6380,_6640),writeChangePids(_6384,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6674),_6684 is _6674-_6438,writeErr(_6684),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6866):-readPAKCSVersion(_6866,_6872),_6872=pakcsVersion(_6876,_6878),prologMajor(_6888),\+_6888=_6878,dir2pofile(_6866,_6904),(existsFile(_6904)->deleteFile(_6904);true),writePAKCSVersion(_6866),!.
ensurePakcsVersion(_7008).
isCurrentPakcsVersion(_7034):-readPAKCSVersion(_7034,_7040),compilerVersion(_7044),!,(_7040=compilerVersion(_7044)->writePAKCSVersion(_7034);_7040=pakcsVersion(_7044,_7070)).
readPAKCSVersion(_7138,_7140):-dir2pakcsversionfile(_7138,_7146),existsFile(_7146),readPrologTermFile(_7146,_7140).
writePAKCSVersion(_7214):-dir2pakcsversionfile(_7214,_7220),compilerVersion(_7224),prologMajor(_7228),writePrologTermFile(_7220,pakcsVersion(_7224,_7228)).
updateDynFactsIfNecessary(_7296,_7298):-isCurrentPakcsVersion(_7296),!.
updateDynFactsIfNecessary(_7360,_7354/_7356):-compilerVersion(_7366),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7360),writeErr('\' to compiler version '),writeErr(_7366),writeErr(...),nlErr;true),updateDynFacts(_7354/_7356),writeNewDatabaseIfChanged(_7354/_7356,_7360,changed),writePAKCSVersion(_7360).
updateDynFactsIfNecessary(_7532,_7534).
updateDynFacts(_7568/_7570):-functor(_7578,_7568,_7570),functor(_7586,_7568,_7570),retract(user:_7578),arg(1,_7578,_7608),arg(1,_7586,_7608),arg(2,_7578,_7624),arg(2,_7586,_7624),translateDynFactArgs(3,_7570,_7578,_7586),asserta(user:_7586),fail.
updateDynFacts(_7744).
translateDynFactArgs(_7770,_7772,_7774,_7776):-_7770>_7772,!.
translateDynFactArgs(_7850,_7852,_7854,_7856):-arg(_7850,_7854,_7864),translateDynFactArg(_7864,_7870),arg(_7850,_7856,_7870),_7888 is _7850+1,translateDynFactArgs(_7888,_7852,_7854,_7856).
translateDynFactArg(_7986,_7986):-var(_7986),!.
translateDynFactArg(_8044,_8044):-number(_8044),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8582,_8584):-atomic(_8582),atom_codes(_8582,[40|_8594]),!,appendAtom('Prelude.',_8582,_8584).
translateDynFactArg(_8672,_8674):-atom(_8672),atom_codes(_8672,[39|_8684]),!,(_8684=[_8694]->char_int(_8674,_8694);_8684=[78,85,76]->char_int(_8674,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8836,_8836):-atomic(_8836),!.
translateDynFactArg(_8894,_8896):-functor(_8894,_8902,_8904),translateDynFactArg(_8902,_8910),functor(_8896,_8910,_8904),translateDynFactArgs(1,_8904,_8894,_8896).
writeNewDatabaseIfChanged(_8992/_8994,_9000,changed):-!,dir2dbfile(_9000,_9008),dir2pofile(_9000,_9014),dir2logfile(_9000,_9020),appendAtom(_9008,'.bak',_9028),tell(_9028),writeq((:-dynamic _8992/_8994)),put_code(46),nl,listing(user:_8992/_8994),told,try_save_predicates(_8992/_8994,_9014),renameFile(_9028,_9008),appendAtom(_9020,'.bak',_9096),renameFile(_9020,_9096),appendAtom('touch ',_9020,_9110),shellCmd(_9110),readDynamicVersion(_9000,_9120),_9130 is _9120+1,writeDynamicVersion(_9000,_9130),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9340/_9342,_9348,_9350):-dir2logfile(_9348,_9356),appendAtom(_9356,'.bak',_9364),renameFile(_9356,_9364),appendAtom('touch ',_9356,_9378),shellCmd(_9378).
readAndReplay(_9460):-atEndOfStream(_9460),!.
readAndReplay(_9508):-read(_9508,_9514),replayEvent(_9508,_9514).
replayEvent(_9564,end_of_file):-!.
replayEvent(_9616,startTransaction(_9612)):-readAndReplayTransaction(_9616,_9612,[]),!,fail.
replayEvent(_9684,_9686):-retract(replayStatus(_9690)),assert(replayStatus(changed)),call(user:_9686),!,fail.
readAndReplayTransaction(_9782,_9784,_9786):-atEndOfStream(_9782),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9784),nlErr;true).
readAndReplayTransaction(_9894,_9896,_9898):-read(_9894,_9904),(_9904=commitTransaction(_9896)->callRevList(_9898);_9904=abortTransaction->true;readAndReplayTransaction(_9894,_9896,[_9904|_9898])),!.
callRevList([]).
callRevList([_10054|_10056]):-callRevList(_10056),retract(replayStatus(_10068)),assert(replayStatus(changed)),call(user:_10054).
startTransaction(_10146).
commitTransaction(_10172).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10210),map1M(prim_dynamic:lockDynamicDir,_10210).
lockDynamicDir(_10256):-dir2lockfile(_10256,_10262),lockWithFile(_10262).
lockWithFileIfNotInTransaction(_10310):-insideTransaction->true;lockWithFile(_10310).
lockWithFile(_10364):-appendAtom('lockfile-create --lock-name ',_10364,_10372),(existsFile(_10364),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10364),writeErr('\'...'),nlErr;true),shellCmd(_10372),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10490),map1M(prim_dynamic:unlockDynamicDir,_10490).
unlockDynamicDir(_10536):-dir2lockfile(_10536,_10542),unlockWithFile(_10542).
unlockWithFileIfNotInTransaction(_10590):-insideTransaction->true;unlockWithFile(_10590).
unlockWithFile(_10644):-existsFile(_10644),!,appendAtom('lockfile-remove --lock-name ',_10644,_10656),shellCmd(_10656).
unlockWithFile(_10716).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10742/_10744,_10750),dynamicVersion(_10750,_10742/_10744,_10770),reloadNewestDynamicVersion(_10750,_10742/_10744,_10770),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10842):-dynamicVersion(_10852,_10842/_10848,_10856),!,reloadNewestDynamicVersion(_10852,_10842/_10848,_10856).
reloadNewestDynamicVersionOf(_10920).
reloadNewestDynamicVersion(_10952,_10946/_10948,0):-!,retractAllFacts(_10946/_10948),replayLogFile(_10952,_10946/_10948),!.
reloadNewestDynamicVersion(_11056,_11050/_11052,_11060):-readDynamicVersion(_11056,_11066),\+_11060=_11066,!,retractAllFacts(_11050/_11052),replayLogFile(_11056,_11050/_11052),!.
reloadNewestDynamicVersion(_11182,_11184,_11186):-readChangePids(_11182,_11192),currentPID(_11196),(_11192=[];_11192=[_11196]),!.
reloadNewestDynamicVersion(_11298,_11292/_11294,_11302):-retractAllFacts(_11292/_11294),replayLogFile(_11298,_11292/_11294).
createDynamicDir(_11390,_11384/_11386):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11390),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11390,_11448),shellCmd(_11448),dir2logfile(_11390,_11458),appendAtom('touch ',_11458,_11466),shellCmd(_11466),dir2dbfile(_11390,_11476),appendAtom('touch ',_11476,_11484),shellCmd(_11484),dir2specfile(_11390,_11494),dynamicSpec(_11384/_11386,_11506),writePrologTermFile(_11494,_11506),writePAKCSVersion(_11390).
readPrologTermFile(_11634,_11636):-open(_11634,read,_11644),read(_11644,_11636),close(_11644).
writePrologTermFile(_11712,_11714):-open(_11712,write,_11722),writeq(_11722,_11714),put_code(_11722,46),nl(_11722),flush_output(_11722),close(_11722).
readDynamicVersion(_11822,_11824):-dir2versionfile(_11822,_11830),existsFile(_11830),!,on_exception(_11850,readPrologTermFile(_11830,_11824),_11824=0).
readDynamicVersion(_11918,1).
writeDynamicVersion(_11954,_11956):-dir2versionfile(_11954,_11962),writePrologTermFile(_11962,_11956).
readChangePids(_12020,_12022):-dir2changepidsfile(_12020,_12028),existsFile(_12028),!,on_exception(_12054,readPrologTermFile(_12028,_12022),_12022=[0]).
readChangePids(_12122,[]).
writeChangePids(_12158,_12160):-dir2changepidsfile(_12158,_12166),writePrologTermFile(_12166,_12160).
addChangePid(_12224):-currentPID(_12228),addChangePid(_12228,_12224).
addChangePid(_12278,_12280):-readChangePids(_12280,_12286),(member(_12278,_12286)->true;writeChangePids(_12280,[_12278|_12286])),!.
dynamicSpec(_12374/_12376,dynamicPredicate(_12374,_12376)).
retractDeadDynamicFacts(_12422/_12424):-length(_12432,_12424),_12444=..[_12422|_12432],_12432=[_12450,_12456|_12458],dynamicTime(_12468),call(user:_12444),_12456>0,_12468>_12456,retract(user:_12444),fail.
retractDeadDynamicFacts(_12586).
dir2logfile(_12612,_12614):-appendAtom(_12612,'/eventlog',_12614).
dir2lockfile(_12668,_12670):-appendAtom(_12668,'/LOCK',_12670).
dir2tmplockfile(_12724,_12726):-appendAtom(_12724,'/LOCK',_12726).
dir2dbfile(_12780,_12782):-appendAtom(_12780,'/database.pl',_12782).
dir2pofile(_12836,_12838):-appendAtom(_12836,'/dbpred.po',_12838).
dir2specfile(_12892,_12894):-appendAtom(_12892,'/spec',_12894).
dir2pakcsversionfile(_12948,_12950):-appendAtom(_12948,'/pakcsversion',_12950).
dir2versionfile(_13004,_13006):-appendAtom(_13004,'/version',_13006).
dir2changepidsfile(_13060,_13062):-appendAtom(_13060,'/changepids',_13062).
