:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_3150):-(getEnv('PAKCS_LOCALHOST',_3156)->true;_3156=no),(_3156=yes->asserta(only_localhost(yes)),_3150=yes;asserta(only_localhost(no)),_3150=no),retract((only_localhost(_3236):-_3240,_3242)),!.
tracePorts(unknown).
ifTracePort(_3334):-tracePorts(_3338),(_3338=unknown->retract(tracePorts(_3348)),(getEnv('PAKCS_TRACEPORTS',_3358)->true;_3358=no),(_3358=yes->asserta(tracePorts(yes)),_3334;asserta(tracePorts(no)));_3338=yes->_3334;true).
prim_openPort(_3502,_3504,_3506):-nonvar(_3502),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_3592,_3594,_3596):-nonvar(_3594),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_3688),_3688,'Prelude.True').
prim_openPortOnSocket(_3738,_3740,_3742):-(retract(mySocket('Ports.internalPort'(_3746,_3748,_3750,_3752)))->_3770 is _3750+1,asserta(mySocket('Ports.internalPort'(_3746,_3748,_3770,_3752))),(_3738=_3748,_3740=_3770->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_3738),on_exception(_3876,listenOnNewSocket(_3738,_3858,_3752),(write('ERROR: openPortOnSocket "'),write(_3738),write('":'),nl,printError(_3876),!,fail)),atom2String(_3858,_3746),(var(_3740)->_3740=0;true),asserta(mySocket('Ports.internalPort'(_3746,_3738,_3740,_3752)))),mySocket(_4000),_4000='Ports.internalPort'(_4004,_4006,_4008,_4010),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_4008),writeErr(' at socket '),writeErr(_4006),writeErr(' on host '),(only_localhost(yes)->writeErr(localhost);string2Atom(_4004,_4056),writeErr(_4056)),writeErr(...),nlErr)),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4000),_3742);_3742='Ports.basicServerLoop'(_4000)).
trySetSocketNumber(_4236):-var(_4236),getEnv('PAKCS_SOCKET',_4246),atom_codes(_4246,_4252),number_codes(_4236,_4252),!.
trySetSocketNumber(_4320).
prim_basicServerLoop(_4624,_4626,_4628,_4630):-freeze(_4628,blocked_prim_basicServerLoop(_4624,_4626,_4628,_4630)).
blocked_prim_basicServerLoop(_4692,_4694,_4696,_4698):-readPort(_4692,_4704,-1),_4694=[_4704|_4712],(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4692),_4712);_4712='Ports.basicServerLoop'(_4692)),_4696=_4698.
prim_timeoutOnStream(_5120,_5122,_5124,_5126,_5128):-freeze(_5126,blocked_prim_timeoutOnStream(_5120,_5122,_5124,_5126,_5128)).
blocked_prim_timeoutOnStream(_5198,_5200,_5202,_5204,_5206):-user:derefRoot(_5198,_5212),prim_timeoutOnStream_exec(_5212,_5200,_5202,_5204,_5206).
prim_timeoutOnStream_exec(_5306,_5308,'Prelude.Nothing',_5312,_5314):-var(_5308),!,_5312=_5314.
prim_timeoutOnStream_exec(_5410,share(_5406),_5414,_5416,_5418):-!,get_mutable(_5422,_5406),(_5422='$eval'(_5428)->_5414=_5428,_5416=_5418;prim_timeoutOnStream_exec(_5410,_5422,_5466,_5416,_5418),(_5466='Prelude.Nothing'->_5414=_5466;(compileWithSharing(variable)->user:propagateShare(_5466,_5414);_5466=_5414),update_mutable('$eval'(_5414),_5406))).
prim_timeoutOnStream_exec(_5642,[],'Prelude.Just'([]),_5648,_5650):-!,_5648=_5650.
prim_timeoutOnStream_exec(_5748,[_5732|_5734],'Prelude.Just'([_5732|_5734]),_5754,_5756):-!,_5754=_5756.
prim_timeoutOnStream_exec(_5842,'Ports.basicServerLoop'(_5838),_5846,_5848,_5850):-(readPort(_5838,_5856,_5842)->(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_5838),_5872);_5872='Ports.basicServerLoop'(_5838)),_5846='Prelude.Just'([_5856|_5872]);_5846='Prelude.Nothing'),_5848=_5850.
send_extvar_binding(_6288,_6290,_6292,_6294):-freeze(_6290,blocked_send_extvar_binding(_6288,_6290,_6292,_6294)).
blocked_send_extvar_binding(_6356,_6358,_6360,_6362):-evalToken(_6366),user:normalizeAndCheck(_6358,_6372,_6366,_6376),user:waitUntilGround(_6372,_6376,_6390),eval_send_extvar_binding(_6356,_6372,_6360,_6390,_6362).
eval_send_extvar_binding(_6792,_6794,_6796,_6798,_6800):-freeze(_6798,blocked_eval_send_extvar_binding(_6792,_6794,_6796,_6798,_6800)).
blocked_eval_send_extvar_binding(nostream,_6872,_6874,_6876,_6878):-writeErr('ERROR: cannot send binding for variable '),writeErr(_6874),writeErr(': '),writeErr(_6872),nlErr,!.
blocked_eval_send_extvar_binding(_6994,_6996,_6998,_7000,_7002):-show4sending(_6996,_7008,_7010),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_6998),writeErr(': '),writeChars(user_error,_7008),nlErr)),number_codes(_6998,_7062),putChars(_6994,[86|_7062]),put_code(_6994,10),writeChars(_6994,_7008),put_code(_6994,10),flush_output(_6994),!,_7002=done.
readPort('Ports.internalPort'(_7226,_7228,_7230,_7232),_7238,_7240):-var(_7232),!,string2Atom(_7226,_7250),writeErr('ERROR: readPort: Port '),writeErr(_7228),writeErr(/),writeErr(_7230),writeErr(@),writeErr(_7250),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_7392,_7394,_7396,_7398),_7404,_7406):-on_exception(_7420,readFromSocket(_7396,_7398,_7404,_7406),(printError(_7420)->_7404=[];_7404=[])),!.
checkIncomingPortStreams(_7512,_7514,_7516):-retract(incomingPortStreams(_7512,[message(_7514,_7516)|_7528])),asserta(incomingPortStreams(_7512,_7528)),!.
checkIncomingPortStreams(_7614,_7616,_7618):-retract(incomingPortStreams(_7614,[ping(_7622,_7624)|_7630])),asserta(incomingPortStreams(_7614,_7630)),answerPingOnStream(_7622,_7624),checkIncomingPortStreams(_7614,_7616,_7618),!.
answerPingOnStream(_7742,_7744):-write(_7744,ok),put_code(_7744,10),flush_output(_7744),closeSocketStream(_7742,_7744),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_7850,_7852,_7854,_7856):-checkIncomingPortStreams(_7850,_7862,_7864),!,readStreamLine(_7862,_7870),(parse_received_message(_7862,_7864,_7870,_7854)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_7870),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_7870),nlErr,readFromSocket(_7850,_7852,_7854,_7856)),!.
readFromSocket(_8042,_8044,_8046,_8048):-waitForSocketClientStream(_8044,_8048,_8056,_8058,_8060),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_8056),nlErr)),(readPortMessage(_8042,_8058,_8060,_8094)->(parse_received_message(_8058,_8060,_8094,_8046)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_8094),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_8094),nlErr,readFromSocket(_8042,_8044,_8046,_8048));readFromSocket(_8042,_8044,_8046,_8048)),!.
readFromSocket(_8282,_8284,_8286,_8288):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_8370,_8372,_8374,_8376):-readStreamLine(_8372,_8382),_8382=[_8386|_8388],checkMessageHeader(_8386,_8372,_8374,_8404),number_codes(_8408,_8388),!,(_8408=_8370->readPortMessageBody(_8404,_8376);(retract(incomingPortStreams(_8408,_8434))->append(_8434,[_8404],_8452);_8452=[_8404]),asserta(incomingPortStreams(_8408,_8452)),!,fail).
checkMessageHeader(78,_8602,_8604,message(_8602,_8604)):-!.
checkMessageHeader(80,_8676,_8678,ping(_8676,_8678)):-!.
checkMessageHeader(_8750,_8752,_8754,_8756):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_8840,_8842),_8848):-readStreamLine(_8840,_8848).
readPortMessageBody(ping(_8900,_8902),_8908):-answerPingOnStream(_8900,_8902),!,fail.
prim_sendPort(_9210,_9212,_9214,_9216,_9218):-freeze(_9216,blocked_prim_sendPort(_9210,_9212,_9214,_9216,_9218)).
blocked_prim_sendPort(_9288,_9290,_9292,_9294,_9296):-user:derefAll(_9288,_9302),user:derefRoot(_9290,_9314),prim_sendPortExec(_9302,_9314,_9292,_9294,_9296).
prim_sendPortExec(_9424,'Ports.internalPort'(_9414,0,_9418,_9420),'Prelude.True',_9430,_9432):-!,add2Stream(_9420,_9424),_9430=_9432.
prim_sendPortExec('Ports.SP_Put'(_9526),'Ports.internalPort'(_9530,-1,_9534,_9536),'Prelude.True',_9546,_9548):-!,user:waitUntilGround(_9526,_9546,_9548),writeChars(_9536,_9526),nl(_9536),flush_output(_9536),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_9526),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_9702),'Ports.internalPort'(_9706,-1,_9710,_9712),'Prelude.True',_9722,_9724):-!,readStreamLine(_9706,_9730),map2M(basics:char_int,_9742,_9730),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_9742),nlErr)),user:constrEq(_9742,_9702,_9778,_9722,_9724).
prim_sendPortExec('Ports.SP_GetChar'(_9882),'Ports.internalPort'(_9886,-1,_9890,_9892),'Prelude.True',_9902,_9904):-!,get_code(_9886,_9910),char_int(_9910,_9916),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_9916),nlErr)),user:constrEq(_9916,_9882,_9948,_9902,_9904).
prim_sendPortExec('Ports.SP_EOF'(_10052),'Ports.internalPort'(_10056,-1,_10060,_10062),'Prelude.True',_10072,_10074):-!,(atEndOfStream(_10056)->_10082='Prelude.True';_10082='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_10082),nlErr)),user:constrEq(_10052,_10082,_10134,_10072,_10074).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_10232,-1,_10236,_10238),'Prelude.True',_10248,_10250):-!,close(_10238),close(_10232),_10248=_10250.
prim_sendPortExec(_10362,'Ports.internalPort'(_10352,-1,_10356,_10358),'Prelude.True',_10368,_10370):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_10362),nlErr,_10368=_10370.
prim_sendPortExec(_10488,'Ports.internalPort'(_10478,_10480,_10482,_10484),'Prelude.True',_10494,_10496):-string2Atom(_10478,_10502),on_exception(_10536,send2Socket(_10502,_10480,_10482,_10488),(write('ERROR: send to port '),write(_10482),write(@),write(_10502),write(:),nl,(printError(_10536)->true;true))),_10494=_10496.
add2Stream(_10680,_10682):-var(_10680),!,_10680=[_10682|_10692].
add2Stream([],_10758):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_10814|_10816],_10822):-add2Stream(_10816,_10822).
prim_ping(_10888,'Ports.internalPort'(_10874,0,_10878,_10880),'Prelude.Just'(0)):-!.
prim_ping(_10960,'Ports.internalPort'(_10946,-1,_10950,_10952),'Prelude.Just'(0)):-!.
prim_ping(_11028,'Ports.internalPort'(_11018,_11020,_11022,_11024),_11032):-string2Atom(_11018,_11038),on_exception(_11060,ping2SocketPort(_11038,_11020,_11022,_11028,_11032),_11032='Prelude.Nothing').
ping2SocketPort(_11124,_11126,_11128,_11130,_11132):-connect2socket(_11124,_11126,_11140,_11142),number_codes(_11128,_11148),putChars(_11142,[80|_11148]),put_code(_11142,10),flush_output(_11142),getElapsedTime(_11174),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_11126),writeErr(/),writeErr(_11128),writeErr(@),writeErr(_11124),writeErr('"'),nlErr)),waitForInputDataOnStreams([_11140],_11130,_11262),(_11262=0->readStreamLine(_11140,_11274),closeSocketStream(_11140,_11142),getElapsedTime(_11284),_11294 is _11284-_11174,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_11294),writeErr(' ms'),nlErr)),_11132='Prelude.Just'(_11294);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_11132='Prelude.Nothing').
prim_connectPortAtSocket(_11536,_11538,_11540,'Ports.internalPort'(_11526,_11528,_11530,'Prelude.()')):-user:derefRoot(_11536,_11528),user:derefRoot(_11538,_11530),user:derefAll(_11540,_11526),!.
send2Socket(_11658,_11660,_11662,_11664):-connect2socket(_11658,_11660,_11672,_11674),number_codes(_11662,_11680),putChars(_11674,[78|_11680]),put_code(_11674,10),show4sending(_11664,_11704,_11706),writeChars(_11674,_11704),put_code(_11674,10),flush_output(_11674),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_11660),writeErr(/),writeErr(_11662),writeErr(@),writeErr(_11658),writeErr('": '),writeChars(user_error,_11704),nlErr)),rev(_11706,_11814),receive_extvar_bindings(_11672,_11814).
receive_extvar_bindings(_11942,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_11942).
receive_extvar_bindings(_12020,_12022):-readStreamLine(_12020,_12028),_12028=[86|_12034],number_codes(_12044,_12034),readStreamLine(_12020,_12052),(deleteIndexVariable(_12044,_12022,_12060,_12062)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_12062=_12022),(parse_received_message(nostream,nostream,_12052,_12106)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_12044),writeErr(': '),putChars(user_error,_12052),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_12052),nlErr),!,_12060=_12106,receive_extvar_bindings(_12020,_12062).
show4sending(_12292,_12294,_12296):-numberVars(_12292,_12302,[],_12296),show_term(_12302,qualified,_12294,[]).
getVariableIndex(_12388,[(_12376,_12378)|_12384],_12378):-_12388==_12376,!.
getVariableIndex(_12464,[_12458|_12460],_12468):-getVariableIndex(_12464,_12460,_12468).
getIndexVariable(_12532,[(_12530,_12532)|_12538],_12530):-!.
getIndexVariable(_12606,[_12600|_12602],_12610):-getIndexVariable(_12606,_12602,_12610).
deleteIndexVariable(_12674,[(_12672,_12674)|_12680],_12672,_12680):-!.
deleteIndexVariable(_12764,[_12752|_12754],_12768,[_12752|_12760]):-deleteIndexVariable(_12764,_12754,_12768,_12760).
parse_received_message(_12842,_12844,_12846,_12848):-readTerm(_12846,qualified,_12856,_12858),skipWhiteSpace(_12856,[]),extractVars(_12858,_12848,[],_12874),send_extvar_bindings(_12874,_12880,_12844),closeStreamAfterDones(_12880,_12842,_12844).
send_extvar_bindings([],[],_12980).
send_extvar_bindings([(_13022,_13024)|_13030],[_13034|_13036],_13044):-send_extvar_binding(_13044,_13022,_13024,_13034),send_extvar_bindings(_13030,_13036,_13044).
closeStreamAfterDones([],nostream,_13126):-!.
closeStreamAfterDones([],_13182,_13184):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_13182,_13184).
closeStreamAfterDones([_13264|_13266],_13272,_13274):-closeStreamAfterDones(_13264,_13266,_13272,_13274).
closeStreamAfterDones(_13622,_13624,_13626,_13628):-freeze(_13622,blocked_closeStreamAfterDones(_13622,_13624,_13626,_13628)).
blocked_closeStreamAfterDones(_13690,_13692,_13694,_13696):-closeStreamAfterDones(_13692,_13694,_13696).
prim_openProcessPort(_13776,'Ports.internalPort'(_13766,-1,0,_13772)):-user:derefAll(_13776,_13784),string2Atom(_13784,_13796),execCommand(_13796,_13772,_13766,_13806).
prim_choiceSPEP(_14156,_14158,_14160,_14162,_14164):-freeze(_14158,freeze(_14162,blocked_prim_choiceSPEP(_14156,_14158,_14160,_14162,_14164))).
blocked_prim_choiceSPEP(_14240,_14242,_14244,_14246,_14248):-user:derefRoot(_14240,_14254),prim_choiceSPEP_exec(_14254,_14242,_14244,_14246,_14248).
prim_choiceSPEP_exec(_14352,share(_14348),_14356,_14358,_14360):-!,get_mutable(_14364,_14348),(_14364='$eval'(_14370)->_14358=_14360,_14356='Prelude.Right'(_14370);prim_choiceSPEP_exec(_14352,_14364,_14412,_14358,_14360),(_14412='Prelude.Left'(_14420)->_14356=_14412;_14412='Prelude.Right'(_14442),(compileWithSharing(variable)->user:propagateShare(_14442,_14458);_14442=_14458),_14356='Prelude.Right'(_14458),update_mutable('$eval'(_14458),_14348))).
prim_choiceSPEP_exec(_14636,[_14620|_14622],'Prelude.Right'([_14620|_14622]),_14642,_14644):-!,_14642=_14644.
prim_choiceSPEP_exec('Ports.internalPort'(_14726,-1,_14730,_14732),[],_14740,_14742,_14744):-readStreamLine(_14726,_14750),map2M(basics:char_int,_14762,_14750),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_14762),nlErr)),_14740='Prelude.Left'(_14762),_14742=_14744,!.
prim_choiceSPEP_exec(_14910,'Ports.basicServerLoop'(_14906),_14914,_14916,_14918):-_14906='Ports.internalPort'(_14922,_14924,_14926,_14928),checkIncomingPortStreams(_14926,_14940,_14942),!,readStreamLine(_14940,_14948),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_14906),_14962);_14962='Ports.basicServerLoop'(_14906)),(parse_received_message(_14940,_14942,_14948,_14994)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_14994),nlErr)),_14914='Prelude.Right'([_14994|_14962]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_14948),nlErr,prim_choiceSPEP_exec(_14910,_14962,_14914,_14916,_14918)),_14916=_14918,!.
prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_96,_98),'Ports.basicServerLoop'(_102),_110,_112,_114):-_102='Ports.internalPort'(_118,_120,_122,_124),waitForSocketOrInputStreams(_124,_142,_144,_146,[_92],_150),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_102),_164);_164='Ports.basicServerLoop'(_102)),(_142=no->readStreamLine(_92,_198),map2M(basics:char_int,_210,_198),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_210),nlErr)),_110='Prelude.Left'(_210);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_142),nlErr)),(readPortMessage(_122,_144,_146,_306)->(parse_received_message(_144,_146,_306,_316)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_316),nlErr)),_110='Prelude.Right'([_316|_164]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_306),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_386,_98),_164,_110,_112,_114));prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_438,_98),_164,_110,_112,_114))),_112=_114,!.
numberVars(_580,'VAR'(_576),_584,_586):-var(_580),!,(getVariableIndex(_580,_584,_576)->_586=_584;length(_584,_576),_586=[(_580,_576)|_584]).
numberVars(_720,_722,_724,_726):-isShowableArg(_720),_720=..[_734|_736],numberVarsList(_736,_748,_724,_726),_722=..[_734|_748].
numberVarsList([],[],_848,_848).
numberVarsList([_900|_902],[_906|_908],_916,_918):-numberVars(_900,_906,_916,_928),numberVarsList(_902,_908,_928,_918).
extractVars(_1006,_1006,_1010,_1010):-var(_1006),!.
extractVars('VAR'(_1084),_1090,_1092,_1094):-!,(getIndexVariable(_1084,_1092,_1090)->_1094=_1092;_1094=[(_1090,_1084)|_1092]).
extractVars(_1206,_1208,_1210,_1212):-_1206=..[_1216|_1218],extractVarsList(_1218,_1230,_1210,_1212),_1208=..[_1216|_1230].
extractVarsList([],[],_1324,_1324).
extractVarsList([_1376|_1378],[_1382|_1384],_1392,_1394):-extractVars(_1376,_1382,_1392,_1404),extractVarsList(_1378,_1384,_1404,_1394).
prim_after(_1700,_1702,_1704,_1706):-freeze(_1704,blocked_prim_after(_1700,_1702,_1704,_1706)).
blocked_prim_after(_1768,_1770,_1772,_1772):-raise_exception('Ports.after not implemented!').
